package net.woodyfolsom.msproj.ann2.math;

import javax.xml.bind.annotation.XmlAttribute;

public abstract class ActivationFunction {
	private String name;
	
	public abstract double calculate(double arg);
	public abstract double derivative(double arg);
	
	public ActivationFunction() {
		//no-arg constructor for JAXB
	}
	
	public ActivationFunction(String name) {
		this.name = name;
	}
	
	@XmlAttribute
	public String getName() {
		return name;
	}
	
	public void setName(String name) {
		this.name = name;
	}
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((name == null) ? 0 : name.hashCode());
		return result;
	}
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ActivationFunction other = (ActivationFunction) obj;
		if (name == null) {
			if (other.name != null)
				return false;
		} else if (!name.equals(other.name))
			return false;
		return true;
	}
	
}